<?php

namespace Picea\ControlStructure;

class SectionToken implements ControlStructure {

    public string $token = "section";

    public function parse(/*\Picae\Compiler\Context*/ &$context, ?string $arguments, string $token) {
        list($name, $options) = array_pad(explode(',', $arguments, 2), 2, null);

        if ( $options ?? false ) {
            $options = eval("return $options;");
        }

        if ( ! ctype_alnum(str_replace([".", "\"", "'", "-", "_"], "", $name)) ) {
            throw new \RuntimeException("Your section named `{$name}` contains invalid character. Allowed are only letters, numbers, dashes, underscores and dots");
        }

        $context->sections[] = [
            'name' => $name,
            'options' => $options,
        ];

        $action = $options['action'] ?? "default";

        if (! in_array($action, ['prepend', 'append', 'default'])) {
            throw new \RuntimeException("An unsupported action `$action` was given as an option of a {% section %} tag");
        }

        $order = $options['order'] ?? "count(\$___class__template->sectionList[$name]['$action'])";

        return "<?php \$___class__template->sectionList[$name] ??= [ 'prepend' => [], 'append' => [], 'default' => [] ];
                      \$___class__template->sectionList[$name]['$action'][] = [ 'order' => $order, 'callback' => function() use (\$picea, \$___class__template, \$___global_variables, \$___variables) {
                          extract(\$___global_variables); extract(\$___variables, \EXTR_OVERWRITE); ?>";
    }
}
